/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner{}

// PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner struct for PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner
type PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner struct {
	OrganizationId *string `json:"organization_id,omitempty"`
	ChannelIds []string `json:"channel_ids,omitempty"`
}

// NewPostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner instantiates a new PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner() *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner {
	this := PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner{}
	return &this
}

// NewPostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInnerWithDefaults instantiates a new PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInnerWithDefaults() *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner {
	this := PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner{}
	return &this
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetChannelIds returns the ChannelIds field value if set, zero value otherwise.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) GetChannelIds() []string {
	if o == nil || IsNil(o.ChannelIds) {
		var ret []string
		return ret
	}
	return o.ChannelIds
}

// GetChannelIdsOk returns a tuple with the ChannelIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) GetChannelIdsOk() ([]string, bool) {
	if o == nil || IsNil(o.ChannelIds) {
		return nil, false
	}
	return o.ChannelIds, true
}

// HasChannelIds returns a boolean if a field has been set.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) HasChannelIds() bool {
	if o != nil && !IsNil(o.ChannelIds) {
		return true
	}

	return false
}

// SetChannelIds gets a reference to the given []string and assigns it to the ChannelIds field.
func (o *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) SetChannelIds(v []string) {
	o.ChannelIds = v
}

func (o PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.ChannelIds) {
		toSerialize["channel_ids"] = o.ChannelIds
	}
	return toSerialize, nil
}

type NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner struct {
	value *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner
	isSet bool
}

func (v NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) Get() *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner {
	return v.value
}

func (v *NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) Set(val *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) {
	v.value = val
	v.isSet = true
}

func (v NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) IsSet() bool {
	return v.isSet
}

func (v *NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner(val *PostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) *NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner {
	return &NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner{value: val, isSet: true}
}

func (v NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePostChannelsChannelIdInteractionsInteractionIdRolloutRolloutIdSchduleRequestOrganizationsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


